<?php
/******************************************************************************
 * include WordPress System
 *****************************************************************************/
require_once('./wp-load.php');

/******************************************************************************
 * Class define
 *****************************************************************************/
class SummaryMorpheme {
	
	var $wpdb;
	var $morphemes = array();
	var $result = array();
	
	/**
	 * SummaryMorpheme
	 * @return unknown_type
	 */
	function SummaryMorpheme($wpdb) {
		
		$this->wpdb = $wpdb;
		
	}
	
	/**
	 * analyze
	 * @return unknown_type
	 */
	function analyze() {
		
		$this->outputStdout("* start morpheme analyze");
		$this->loadMorpheme();
		$this->summaryMorphemes();
		$this->outputStdout("* end morpheme analyze");
		
	}
	
	/**
	 * loadMorpheme
	 * @return unknown_type
	 */
	function loadMorpheme() {
		
		$this->outputStdout("** start load all morpheme");
		
		$this->morphemes = $this->wpdb->get_col(
			"SELECT"
			. " xml_uniq"
			. " FROM"
			. "     {$this->wpdb->prefix}morpheme"
			. " ORDER BY"
			. "     update_time ASC");
		if(count($this->morphemes) == 0) {
			$this->outputStdout("** FATAL ERROR! abnormal terminated");
			die();
		}
		
		$this->outputStdout("** end load all morpheme");
		
	}
	
	/**
	 * summaryMorpheme
	 * @return unknown_type
	 */
	function summaryMorphemes() {
		
		$this->outputStdout("** start summary morpheme");
		
		$warning = 0;
		foreach($this->morphemes as $xml) {
			$morphemes = @simplexml_load_string($xml);
			if($morphemes === false) {
				$warning++;
				continue;
			}
			foreach($morphemes->uniq_result->word_list->word as $word) {
				if($word->pos != '名詞') continue;
				$this->result["$word->surface"] += $word->count; 
			}
		}
		arsort($this->result);
		
		$this->outputStdout("** end summary morpheme (warning $warning count)");
		
	}
	
	/**
	 * outputResult
	 * @return unknown_type
	 */
	function outputResult() {
		
		$option = get_option('WpJRelated');
		
		echo "\nそれでは " . get_bloginfo('name') . " の頻出語を発表します!\n\n";
		$rank = 0;
		$rank_temp = 0;
		$count_temp = 0;
		foreach($this->result as $word => $count) {
			if(mb_strpos($option->stopWord, $word) !== false) {
				continue;
			} 
			if($count_temp != $count) {
				$rank++;
				$rank += $rank_temp;
				$rank_temp = 0;
				$count_temp = $count;
			} else {
				$rank_temp++;
			}
			echo sprintf("%4d位\t(%4d出現)\t%s\n", $rank, $count, $word);
		}
		
	}
	
	/**
	 * outputStdout
	 * @param $message
	 */
	function outputStdout($message) {
		
		echo date('Y-m-d h:i:s') . " : " . $message . "\n";
		
	}
	
}

/******************************************************************************
 * Main
 *****************************************************************************/

$summaryMorpheme = new SummaryMorpheme($wpdb);

echo "<html><body><pre>\n";
$summaryMorpheme->analyze();
$summaryMorpheme->outputResult();
echo "</pre></body></html>\n";

?>
